searchNodes=[{"doc":"","ref":"Extism.html","title":"Extism","type":"module"},{"doc":"","ref":"Extism.html#set_log_file/2","title":"Extism.set_log_file/2","type":"function"},{"doc":"A CancelHandle is a handle generated by a plugin that allows it to be cancelled from another thread while running.","ref":"Extism.CancelHandle.html","title":"Extism.CancelHandle","type":"module"},{"doc":"Cancel plugin execution","ref":"Extism.CancelHandle.html#cancel/1","title":"Extism.CancelHandle.cancel/1","type":"function"},{"doc":"","ref":"Extism.CancelHandle.html#wrap_resource/1","title":"Extism.CancelHandle.wrap_resource/1","type":"function"},{"doc":"A Context is needed to create plugins. The Context is where your plugins live. Freeing the context frees all of the plugins in its scope.","ref":"Extism.Context.html","title":"Extism.Context","type":"module"},{"doc":"Frees the context from memory and all of its plugins.","ref":"Extism.Context.html#free/1","title":"Extism.Context.free/1","type":"function"},{"doc":"Creates a new context.","ref":"Extism.Context.html#new/0","title":"Extism.Context.new/0","type":"function"},{"doc":"Create a new plugin from a WASM module or manifest Examples: iex&gt; ctx = Extism.Context . new ( ) iex&gt; manifest = %{ wasm : [ %{ path : &quot;/Users/ben/code/extism/wasm/code.wasm&quot; } ] } iex&gt; { :ok , plugin } = Extism.Context . new_plugin ( ctx , manifest , false ) Parameters ctx: The Context to manage this plugin manifest: The String or Map of the WASM module or manifest wasi: A bool you set to true if you want WASI support","ref":"Extism.Context.html#new_plugin/3","title":"Extism.Context.new_plugin/3","type":"function"},{"doc":"Resets the context. This has the effect of freeing all the plugins created so far.","ref":"Extism.Context.html#reset/1","title":"Extism.Context.reset/1","type":"function"},{"doc":"","ref":"Extism.Context.html#wrap_resource/1","title":"Extism.Context.wrap_resource/1","type":"function"},{"doc":"This module represents the Native Extism runtime API and is for internal use. Do not use or rely on this this module.","ref":"Extism.Native.html","title":"Extism.Native","type":"module"},{"doc":"","ref":"Extism.Native.html#context_free/1","title":"Extism.Native.context_free/1","type":"function"},{"doc":"","ref":"Extism.Native.html#context_new/0","title":"Extism.Native.context_new/0","type":"function"},{"doc":"","ref":"Extism.Native.html#context_reset/1","title":"Extism.Native.context_reset/1","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_call/4","title":"Extism.Native.plugin_call/4","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_cancel/1","title":"Extism.Native.plugin_cancel/1","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_cancel_handle/2","title":"Extism.Native.plugin_cancel_handle/2","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_free/2","title":"Extism.Native.plugin_free/2","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_has_function/3","title":"Extism.Native.plugin_has_function/3","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_new_with_manifest/3","title":"Extism.Native.plugin_new_with_manifest/3","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_update_manifest/4","title":"Extism.Native.plugin_update_manifest/4","type":"function"},{"doc":"","ref":"Extism.Native.html#set_log_file/2","title":"Extism.Native.set_log_file/2","type":"function"},{"doc":"A Plugin represents an instance of your WASM program from the given manifest.","ref":"Extism.Plugin.html","title":"Extism.Plugin","type":"module"},{"doc":"Call a plugin's function by name Examples iex&gt; { :ok , plugin } = Extism.Context . new_plugin ( ctx , manifest , false ) iex&gt; { :ok , output } = Extism.Plugin . call ( plugin , &quot;count_vowels&quot; , &quot;this is a test&quot; ) # {:ok, &quot;{&quot;count&quot;: 4}&quot;} Parameters plugin: The plugin name: The name of the function as a string input: The input data as a string Returns A string representation of the functions output","ref":"Extism.Plugin.html#call/3","title":"Extism.Plugin.call/3","type":"function"},{"doc":"Frees the plugin","ref":"Extism.Plugin.html#free/1","title":"Extism.Plugin.free/1","type":"function"},{"doc":"Returns true if the given plugin responds to the given function name","ref":"Extism.Plugin.html#has_function/2","title":"Extism.Plugin.has_function/2","type":"function"},{"doc":"Updates the manifest of the given plugin Parameters ctx: The Context to manage this plugin manifest: The String or Map of the WASM module or manifest wasi: A bool you set to true if you want WASI support","ref":"Extism.Plugin.html#update/3","title":"Extism.Plugin.update/3","type":"function"},{"doc":"","ref":"Extism.Plugin.html#wrap_resource/2","title":"Extism.Plugin.wrap_resource/2","type":"function"},{"doc":"Extism Host SDK for Elixir and Erlang","ref":"readme.html","title":"Extism","type":"extras"},{"doc":"Read the docs on hexdocs.pm .","ref":"readme.html#docs","title":"Extism - Docs","type":"extras"},{"doc":"You can find this package on hex.pm . def deps do [ { :extism , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Extism - Installation","type":"extras"},{"doc":"Example # Create a context for which plugins can be allocated and cleaned ctx = Extism.Context . new ( ) # point to some wasm code, this is the count_vowels example that ships with extism manifest = %{ wasm : [ %{ path : &quot;/Users/ben/code/extism/wasm/code.wasm&quot; } ] } { :ok , plugin } = Extism.Context . new_plugin ( ctx , manifest , false ) # {:ok, # %Extism.Plugin{ # resource: 0, # reference: #Reference&lt;0.520418104.1263009793.80956&gt; # }} { :ok , output } = Extism.Plugin . call ( plugin , &quot;count_vowels&quot; , &quot;this is a test&quot; ) # {:ok, &quot;{\\&quot;count\\&quot;: 4}&quot;} { :ok , result } = JSON . decode ( output ) # {:ok, %{&quot;count&quot; =&gt; 4}} # free up the context and any plugins we allocated Extism.Context . free ( ctx ) Modules The two primary modules you should learn are: Extism.Context Extism.Plugin Context The Context can be thought of as a session. You need a context to interact with the Extism runtime. The context holds your plugins and when you free the context, it frees your plugins. It's important to free up your context and plugins when you are done with them. ctx = Extism.Context . new ( ) # frees all the plugins Extism.Context . reset ( ctx ) # frees the context and all its plugins Extism.Context . free ( ctx ) Plugin The Plugin represents an instance of your WASM program from the given manifest. The key method to know here is Extism.Plugin#call which takes a function name to invoke and some input data, and returns the results from the plugin. { :ok , plugin } = Extism.Context . new_plugin ( ctx , manifest , false ) { :ok , output } = Extism.Plugin . call ( plugin , &quot;count_vowels&quot; , &quot;this is a test&quot; )","ref":"readme.html#getting-started","title":"Extism - Getting Started","type":"extras"}]